DEFINE LCD_DREG PORTB 
DEFINE LCD_DBIT 4 
DEFINE LCD_RSREG PORTB 
DEFINE LCD_RSBIT 3 
DEFINE LCD_EREG PORTB 
DEFINE LCD_EBIT 0 
DEFINE LCD_BITS 4 
DEFINE LCD_Lines 2 
DEFINE LCD_CommandUs 2000 
DEFINE LCD_DataUs 50 
;--------------------------------------------------------------------------
ADCON1 = %00000100
TRISB = %00000000 
PORTB = %00000000
TRISC = %00000001
PORTC = %00000000
;--------------------------------------------------------------------------
TempDat1   VAR  WORD        ' RAW Temperature readings
TempCel1   VAR  WORD        '   
TempDes1   VAR  WORD        '   
TempTemp1  VAR  WORD        '   
Temper     var  word
;--------------------------------------------------------------------------
Busy1      VAR BIT         ' Busy Status-Bit
Comm_Pin   VAR	PortC.0     ' One-wire Data-Pin "DQ" on PortC.0
ColdBit1   VAR  TempTemp1.Bit11'   
;---------------------------------------------------------------------------
LCDOUT $FE, 1 '   
LCDOUT $FE,$C0,"DS18B20"
PAUSE 80
;--------------------   -----------------------------------
Start_Convert: 
OWOUT   Comm_Pin, 1, [$CC, $44]' Skip ROM search & do temp conversion
;---------------------------------------------------------------------------    
Wait_Up:
    OWIN    Comm_Pin, 4, [Busy1]    ' Read busy-bit    
    IF      Busy1 = 0 THEN Wait_Up  ' Still busy..?, Wait_Up..!    
    OWOUT   Comm_Pin, 1, [$CC, $BE]' Skip ROM search & read scratchpad memory    
    OWIN    Comm_Pin, 2, [TempTemp1.Lowbyte, TempTemp1.Highbyte]' Read two bytes / end comms       
    GOSUB   Convert_Temp
    GOTO    Start_Convert
;---------------------   -----------------------------    
Convert_Temp:                 
if ColdBit1 <> 1 then 
    tempcel1 = temptemp1 / 16
    tempdes1 = (temptemp1 // 16) * 10 / 16
    lcdout $fe, 1, #tempcel1, ".", #tempdes1 
else
    tempcel1 = 65535 - temptemp1
    tempdat1 = tempcel1 + 1
    tempcel1 = tempdat1 / 16
    tempdes1 = ((tempdat1 + 1) // 16) * 10 / 16
    lcdout $fe, 1, "-", #tempcel1, ".", #tempdes1 
endif 
    pause 500    
RETURN
goto Convert_Temp    
'GoTo main ' 
'end
